diff --git a/contrib/gmm/gmm_std.h b/contrib/gmm/gmm_std.h
index 82aa9f84ba..d3a5320a01 100644
--- a/contrib/gmm/gmm_std.h
+++ b/contrib/gmm/gmm_std.h
@@ -1,38 +1,39 @@
-// -*- c++ -*- (enables emacs c++ mode)
-//===========================================================================
-//
-// Copyright (C) 1995-2008 Yves Renard
-//
-// This file is a part of GETFEM++
-//
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
-//
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
-//
-//===========================================================================
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2002-2020 Yves Renard
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
 
 /**@file gmm_std.h
-   @author  Yves Renard <Yves.Renard@insa-lyon.fr>,
-   @author  Julien Pommier <Julien.Pommier@insa-toulouse.fr>
-   @date June 01, 1995.
-   @brief basic setup for gmm (includes, typedefs etc.)
+@author  Yves Renard <Yves.Renard@insa-lyon.fr>,
+@author  Julien Pommier <Julien.Pommier@insa-toulouse.fr>
+@date June 01, 1995.
+@brief basic setup for gmm (includes, typedefs etc.)
 */
 #ifndef GMM_STD_H__
 #define GMM_STD_H__
@@ -55,8 +56,8 @@
 # define SECURE_NONCHAR_FSCANF fscanf_s
 # define SECURE_STRNCPY(a, la, b, lb) strncpy_s(a, la, b, lb)
 # define SECURE_FOPEN(F, filename, mode) (*(F) = 0,  fopen_s(F, filename, mode))
-# define SECURE_SPRINTF1(S, l, st, p1) sprintf_s(S, l, st, p1) 
-# define SECURE_SPRINTF2(S, l, st, p1, p2) sprintf_s(S, l, st, p1, p2) 
+# define SECURE_SPRINTF1(S, l, st, p1) sprintf_s(S, l, st, p1)
+# define SECURE_SPRINTF2(S, l, st, p1, p2) sprintf_s(S, l, st, p1, p2)
 # define SECURE_SPRINTF4(S, l, st, p1, p2, p3, p4) sprintf_s(S, l, st, p1, p2, p3, p4)
 # define SECURE_STRDUP(s) _strdup(s)
 # ifndef _SCL_SECURE_NO_DEPRECATE
@@ -69,41 +70,33 @@
 # define SECURE_FOPEN(F, filename, mode) ((*(F)) = fopen(filename, mode))
 # define SECURE_SPRINTF1(S, l, st, p1) sprintf(S, st, p1)
 # define SECURE_SPRINTF2(S, l, st, p1, p2) sprintf(S, st, p1, p2)
-# define SECURE_SPRINTF4(S, l, st, p1, p2, p3, p4) sprintf(S, st, p1, p2, p3, p4) 
+# define SECURE_SPRINTF4(S, l, st, p1, p2, p3, p4) sprintf(S, st, p1, p2, p3, p4)
 # define SECURE_STRDUP(s) strdup(s)
 #endif
 
-
-#if !defined(GMM_USES_MPI) && GETFEM_PARA_LEVEL > 0
-# define GMM_USES_MPI
-#endif
+inline void GMM_NOPERATION_(int) { }
+#define GMM_NOPERATION(a) { GMM_NOPERATION_(abs(&(a) != &(a))); }
 
 /* ********************************************************************** */
 /*	Compilers detection.						  */
 /* ********************************************************************** */
 
-/* for sun CC 5.0 ...
-#if defined(__SUNPRO_CC) && __SUNPRO_CC >= 0x500
-# include <stdcomp.h>
-# undef _RWSTD_NO_CLASS_PARTIAL_SPEC
-# undef _RWSTD_NO_NAMESPACE
-#endif 
-*/
 /* for VISUAL C++ ...
-   #if defined(_MSC_VER) //  && !defined(__MWERKS__)
-   #define _GETFEM_MSVCPP_ _MSC_VER
-   #endif
+#if defined(_MSC_VER) //  && !defined(__MWERKS__)
+#define _GETFEM_MSVCPP_ _MSC_VER
+#endif
 */
 
 #if defined(__GNUC__)
-#  if (__GNUC__ < 3)
-#    error : PLEASE UPDATE g++ TO AT LEAST 3.0 VERSION
+#  if (__GNUC__ < 4)
+#    error : PLEASE UPDATE g++ TO AT LEAST 4.8 VERSION
 #  endif
 #endif
 
 /* ********************************************************************** */
 /*	C++ Standard Headers.						  */
 /* ********************************************************************** */
+#include <clocale>
 #include <cstdlib>
 #include <cstddef>
 #include <cmath>
@@ -112,7 +105,7 @@
 #include <cassert>
 #include <climits>
 #include <iostream>
-//#include <ios> 
+//#include <ios>
 #include <fstream>
 #include <ctime>
 #include <exception>
@@ -127,17 +120,88 @@
 #include <limits>
 #include <sstream>
 #include <numeric>
+#include <memory>
+#include <array>
+#include <locale.h>
+
+//#include <gmm/gmm_arch_config.h>
+
+namespace std {
+#if defined(__GNUC__) && (__cplusplus <= 201103L)
+  template<typename _Tp>
+    struct _MakeUniq
+    { typedef unique_ptr<_Tp> __single_object; };
+  template<typename _Tp>
+    struct _MakeUniq<_Tp[]>
+    { typedef unique_ptr<_Tp[]> __array; };
+  template<typename _Tp, size_t _Bound>
+    struct _MakeUniq<_Tp[_Bound]>
+    { struct __invalid_type { }; };
+  /// std::make_unique for single objects
+  template<typename _Tp, typename... _Args>
+    inline typename _MakeUniq<_Tp>::__single_object
+    make_unique(_Args&&... __args)
+    { return unique_ptr<_Tp>(new _Tp(std::forward<_Args>(__args)...)); }
+  /// std::make_unique for arrays of unknown bound
+  template<typename _Tp>
+    inline typename _MakeUniq<_Tp>::__array
+    make_unique(size_t __num)
+    { return unique_ptr<_Tp>(new typename remove_extent<_Tp>::type[__num]()); }
+  /// Disable std::make_unique for arrays of known bound
+  template<typename _Tp, typename... _Args>
+    inline typename _MakeUniq<_Tp>::__invalid_type
+    make_unique(_Args&&...) = delete;
+#endif
+
 
+  // Should simply be replaced by std::shared_ptr<T[]> when it will be supported
+  // by the STL
+  template <typename T> class shared_array_ptr : shared_ptr<T> {
+  public:
+    shared_array_ptr() {}
+    shared_array_ptr(T *q) : std::shared_ptr<T>(q, default_delete<T[]>()) {}
+    template <typename Y> shared_array_ptr(const std::shared_ptr<Y> &p, T *q)
+      : std::shared_ptr<T>(p, q) {}
+    T *get() const { return shared_ptr<T>::get(); }
+    T& operator*() const { return shared_ptr<T>::operator*(); }
+    T* operator->() const { return shared_ptr<T>::operator->(); }
+  };
 
-using std::endl; using std::cout; using std::cerr;
-using std::ends; using std::cin;
+  template <typename T> shared_array_ptr<T> make_shared_array(size_t num)
+  { return shared_array_ptr<T>(new T[num]); }
+}
 
 namespace gmm {
 
+  using std::endl; using std::cout; using std::cerr;
+        using std::ends; using std::cin; using std::isnan;
+
+  class standard_locale {
+    std::string cloc;
+    std::locale cinloc;
+
+  public :
+    inline standard_locale(void)
+      : cloc(setlocale(LC_NUMERIC, 0)), cinloc(cin.getloc())
+    { setlocale(LC_NUMERIC,"C"); cin.imbue(std::locale("C")); }
+    inline ~standard_locale()
+    { setlocale(LC_NUMERIC, cloc.c_str()); cin.imbue(cinloc); }
+  };
+
+  class stream_standard_locale {
+    std::locale cloc;
+    std::ios &io;
+
+  public :
+    inline stream_standard_locale(std::ios &i)
+      : cloc(i.getloc()), io(i) { io.imbue(std::locale("C")); }
+    inline ~stream_standard_locale() { io.imbue(cloc); }
+  };
+
   /* ******************************************************************* */
   /*       Clock functions.                                              */
   /* ******************************************************************* */
-  
+
 # if  defined(HAVE_SYS_TIMES)
   inline double uclock_sec(void) {
     static double ttclk = 0.;
@@ -148,16 +212,16 @@ namespace gmm {
   inline double uclock_sec(void)
   { return double(clock())/double(CLOCKS_PER_SEC); }
 # endif
-  
+
   /* ******************************************************************** */
   /*	Fixed size integer types.                     			  */
   /* ******************************************************************** */
-  // Remark : the test program dynamic_array tests the lenght of
+  // Remark : the test program dynamic_array tests the length of
   //          resulting integers
 
   template <size_t s> struct fixed_size_integer_generator {
     typedef void int_base_type;
-    typedef void uint_base_type;  
+    typedef void uint_base_type;
   };
 
   template <> struct fixed_size_integer_generator<sizeof(char)> {
@@ -167,36 +231,36 @@ namespace gmm {
 
   template <> struct fixed_size_integer_generator<sizeof(short int)
     - ((sizeof(short int) == sizeof(char)) ? 78 : 0)> {
-    typedef signed short int int_base_type;
-    typedef unsigned short int uint_base_type;
-  };
+  typedef signed short int int_base_type;
+  typedef unsigned short int uint_base_type;
+};
 
-  template <> struct fixed_size_integer_generator<sizeof(int)
-    - ((sizeof(int) == sizeof(short int)) ? 59 : 0)> {
+template <> struct fixed_size_integer_generator<sizeof(int)
+  - ((sizeof(int) == sizeof(short int)) ? 59 : 0)> {
     typedef signed int int_base_type;
     typedef unsigned int uint_base_type;
   };
- 
-  template <> struct fixed_size_integer_generator<sizeof(long)
-    - ((sizeof(int) == sizeof(long)) ? 93 : 0)> {
+
+template <> struct fixed_size_integer_generator<sizeof(long)
+  - ((sizeof(int) == sizeof(long)) ? 93 : 0)> {
     typedef signed long int_base_type;
     typedef unsigned long uint_base_type;
   };
 
-  template <> struct fixed_size_integer_generator<sizeof(long long)
-    - ((sizeof(long long) == sizeof(long)) ? 99 : 0)> {
+template <> struct fixed_size_integer_generator<sizeof(long long)
+  - ((sizeof(long long) == sizeof(long)) ? 99 : 0)> {
     typedef signed long long int_base_type;
     typedef unsigned long long uint_base_type;
   };
- 
-  typedef fixed_size_integer_generator<1>::int_base_type int8_type;
-  typedef fixed_size_integer_generator<1>::uint_base_type uint8_type;
-  typedef fixed_size_integer_generator<2>::int_base_type int16_type;
-  typedef fixed_size_integer_generator<2>::uint_base_type uint16_type;
-  typedef fixed_size_integer_generator<4>::int_base_type int32_type;
-  typedef fixed_size_integer_generator<4>::uint_base_type uint32_type;
-  typedef fixed_size_integer_generator<8>::int_base_type int64_type;
-  typedef fixed_size_integer_generator<8>::uint_base_type uint64_type;
+
+typedef fixed_size_integer_generator<1>::int_base_type int8_type;
+typedef fixed_size_integer_generator<1>::uint_base_type uint8_type;
+typedef fixed_size_integer_generator<2>::int_base_type int16_type;
+typedef fixed_size_integer_generator<2>::uint_base_type uint16_type;
+typedef fixed_size_integer_generator<4>::int_base_type int32_type;
+typedef fixed_size_integer_generator<4>::uint_base_type uint32_type;
+typedef fixed_size_integer_generator<8>::int_base_type int64_type;
+typedef fixed_size_integer_generator<8>::uint_base_type uint64_type;
 
 // #if INT_MAX == 32767
 //   typedef signed int    int16_type;
@@ -235,23 +299,54 @@ namespace gmm {
 // #endif
 
 #if defined(__GNUC__) && !defined(__ICC)
-/* 
-   g++ can issue a warning at each usage of a function declared with this special attribute 
+/*
+   g++ can issue a warning at each usage of a function declared with this special attribute
    (also works with typedefs and variable declarations)
 */
-//# define IS_DEPRECATED __attribute__ ((__deprecated__))
-// annoying : just including .h files e.g. gmm_precond_ildlt.h generates lots of useless warnings with new 4.6+ gcc.
-# define IS_DEPRECATED
+# define IS_DEPRECATED __attribute__ ((__deprecated__))
 /*
-   the specified function is inlined at any optimization level 
+  the specified function is inlined at any optimization level
 */
 # define ALWAYS_INLINE __attribute__((always_inline))
 #else
 # define IS_DEPRECATED
 # define ALWAYS_INLINE
 #endif
-  
+
 }
 
-#endif /* GMM_STD_H__ */
+  /* ******************************************************************** */
+  /*	Import/export classes and interfaces from a shared library          */
+  /* ******************************************************************** */
 
+#if defined(EXPORTED_TO_SHARED_LIB)
+#  if defined(_MSC_VER) || defined(__INTEL_COMPILER)
+#     define APIDECL __declspec(dllexport)
+#  elif defined(__GNUC__)
+#     define __attribute__((visibility("default")))
+#  else
+#     define APIDECL
+#  endif
+#   if defined(IMPORTED_FROM_SHARED_LIB)
+#	  error INTENTIONAL COMPILCATION ERROR, DLL IMPORT AND EXPORT ARE INCOMPITABLE
+#   endif
+#endif
+
+#if defined(IMPORTED_FROM_SHARED_LIB)
+#  if defined(_MSC_VER) || defined(__INTEL_COMPILER)
+#     define APIDECL __declspec(dllimport)
+#  else
+#     define APIDECL
+#  endif
+#   if defined(EXPORTED_TO_SHARED_LIB)
+#	  error INTENTIONAL COMPILCATION ERROR, DLL IMPORT AND EXPORT ARE INCOMPITABLE
+#   endif
+#endif
+
+#ifndef EXPORTED_TO_SHARED_LIB
+#  ifndef IMPORTED_FROM_SHARED_LIB
+#    define APIDECL  //empty, used during static linking
+#  endif
+#endif
+
+#endif /* GMM_STD_H__ */
diff --git a/contrib/gmm/gmm_sub_index.h b/contrib/gmm/gmm_sub_index.h
index 387c70701f..28c95e0dea 100644
--- a/contrib/gmm/gmm_sub_index.h
+++ b/contrib/gmm/gmm_sub_index.h
@@ -1,32 +1,33 @@
-// -*- c++ -*- (enables emacs c++ mode)
-//===========================================================================
-//
-// Copyright (C) 2002-2008 Yves Renard
-//
-// This file is a part of GETFEM++
-//
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
-//
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
-//
-//===========================================================================
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2002-2020 Yves Renard
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
 
 /**@file gmm_sub_index.h
    @author  Yves Renard <Yves.Renard@insa-lyon.fr>
@@ -105,38 +106,41 @@ namespace gmm {
 	{ first_ = std::min(first_, *it); last_ = std::max(last_, *it); }
     }
 
-    // inline void test_rind(void) const
-    //  { if (!rind) rind = index_generator::create_rindex(ind); }
+    inline void test_rind(void) const
+    { if (!rind) rind = index_generator::create_rindex(ind); }
     size_type size(void) const { return ind->size(); }
     size_type first(void) const { return first_; }
     size_type last(void) const { return last_; }
     size_type index(size_type i) const { return (*ind)[i]; }
     size_type rindex(size_type i) const {
-      // test_rind();
+      test_rind();
       if (i < rind->size()) return (*rind)[i]; else return size_type(-1);
     }
    
     const_iterator  begin(void) const { return  ind->begin(); }
     const_iterator    end(void) const { return  ind->end();   }
-    const_iterator rbegin(void) const {/*test_rind();*/ return rind->begin(); }
-    const_iterator   rend(void) const {/*test_rind();*/ return rind->end();   }
+    const_iterator rbegin(void) const { test_rind(); return rind->begin(); }
+    const_iterator   rend(void) const { test_rind(); return rind->end();   }
 
     sub_index() : ind(0), rind(0) {}
     template <typename IT> sub_index(IT it, IT ite)
       : ind(index_generator::create_index(it, ite)),
-	rind(index_generator::create_rindex(ind)) { comp_extr(); }
+	rind(0) { comp_extr(); }
     template <typename CONT> sub_index(const CONT &c)
       : ind(index_generator::create_index(c.begin(), c.end())),
-	rind(index_generator::create_rindex(ind))
-        { comp_extr(); }
-    ~sub_index()
-      { index_generator::unattach(rind); index_generator::unattach(ind); }
+	rind(0) { comp_extr(); }
+    ~sub_index() {
+      index_generator::unattach(rind);
+      index_generator::unattach(ind);
+    }
     sub_index(const sub_index &si) : first_(si.first_), last_(si.last_),
 				     ind(si.ind), rind(si.rind)
-      { index_generator::attach(rind); index_generator::attach(ind); }
+    { index_generator::attach(rind); index_generator::attach(ind); }
     sub_index &operator =(const sub_index &si) {
-      index_generator::unattach(rind); index_generator::unattach(ind);
-      ind = si.ind; rind = si.rind; index_generator::attach(rind);
+      index_generator::unattach(rind);
+      index_generator::unattach(ind);
+      ind = si.ind; rind = si.rind;
+      index_generator::attach(rind);
       index_generator::attach(ind);
       first_ = si.first_; last_ = si.last_;
       return *this;
@@ -144,12 +148,15 @@ namespace gmm {
   };
 
   struct unsorted_sub_index : public sub_index {
+    typedef basic_index base_type;
+    typedef base_type::const_iterator const_iterator;
+    
     template <typename IT> unsorted_sub_index(IT it, IT ite)
       : sub_index(it, ite) {}
     template <typename CONT> unsorted_sub_index(const CONT &c)
       : sub_index(c) {}
     unsorted_sub_index() {}
-    unsorted_sub_index(const unsorted_sub_index &si) : sub_index(si) {}
+    unsorted_sub_index(const unsorted_sub_index &si) : sub_index((const sub_index &)(si)) { }
     unsorted_sub_index &operator =(const unsorted_sub_index &si)
     { sub_index::operator =(si); return *this; }
     void swap(size_type i, size_type j) {
diff --git a/contrib/gmm/gmm_sub_matrix.h b/contrib/gmm/gmm_sub_matrix.h
index efc36bcf69..998a766234 100644
--- a/contrib/gmm/gmm_sub_matrix.h
+++ b/contrib/gmm/gmm_sub_matrix.h
@@ -1,32 +1,33 @@
-// -*- c++ -*- (enables emacs c++ mode)
-//===========================================================================
-//
-// Copyright (C) 2002-2008 Yves Renard
-//
-// This file is a part of GETFEM++
-//
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
-//
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
-//
-//===========================================================================
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2002-2020 Yves Renard
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
 
 /**@file gmm_sub_matrix.h
    @author Yves Renard <Yves.Renard@insa-lyon.fr>
@@ -142,11 +143,11 @@ namespace gmm {
     typedef abstract_null_type col_iterator;
     typedef abstract_null_type const_sub_col_type;
     typedef abstract_null_type const_col_iterator;
-    typedef typename sub_vector_type<const typename
-            linalg_traits<M>::const_sub_row_type *, SUBI2>::vector_type
+    typedef typename sub_vector_type<const typename org_type<typename
+	    linalg_traits<M>::const_sub_row_type>::t *, SUBI2>::vector_type
             const_sub_row_type;
     typedef typename select_ref<abstract_null_type, 
-            typename sub_vector_type<typename linalg_traits<M>::sub_row_type *,
+	    typename sub_vector_type<typename org_type<typename linalg_traits<M>::sub_row_type>::t *,
 	    SUBI2>::vector_type, PT>::ref_type sub_row_type;
     typedef gen_sub_row_matrix_iterator<typename const_pointer<PT>::pointer,
 	    SUBI1, SUBI2> const_row_iterator;
@@ -289,12 +290,8 @@ namespace gmm {
     typedef abstract_null_type row_iterator;
     typedef abstract_null_type const_sub_row_type;
     typedef abstract_null_type const_row_iterator;
-    typedef typename sub_vector_type<const typename
-            linalg_traits<M>::const_sub_col_type *, SUBI1>::vector_type
-            const_sub_col_type;
-    typedef typename select_ref<abstract_null_type, 
-            typename sub_vector_type<typename linalg_traits<M>::sub_col_type *,
-	    SUBI1>::vector_type, PT>::ref_type sub_col_type;
+    typedef typename sub_vector_type<const typename org_type<typename linalg_traits<M>::const_sub_col_type>::t *, SUBI1>::vector_type const_sub_col_type;
+    typedef typename select_ref<abstract_null_type, typename sub_vector_type<typename org_type<typename linalg_traits<M>::sub_col_type>::t *, SUBI1>::vector_type, PT>::ref_type sub_col_type;
     typedef gen_sub_col_matrix_iterator<typename const_pointer<PT>::pointer,
 	    SUBI1, SUBI2> const_col_iterator;
     typedef typename select_ref<abstract_null_type, 
